#version 400

uniform sampler2D tex1;
uniform sampler2D tex2bw;

in vec2 vuv;

out vec4 outCol;

const float near = 0.15;
const float far = 0.01;

void main()
{
	vec4 lookupT1 = texture(tex1,vuv);
	vec4 blendTexColor = texture(tex2bw,vuv);
	
	float blending = 1.0f - blendTexColor.r;

	outCol = lookupT1 * blending;
	outCol.a = 1.0f;
}