#version 400

uniform sampler2D textureMap;
uniform bool horizontal;
uniform float step;

in vec2 vuv;

out vec4 outColor;

const float[7] weights = float[7](0.07, 0.11, 0.19, 0.26, 0.19, 0.11, 0.07);

void main()
{
	if(horizontal)
	{
		vec4 sumCol = vec4(0.0f,0.0f,0.0f,1.0f);
		for(int i=0; i<3; ++i)
		{
			if(i==0)
			{
				sumCol += texture(textureMap,vuv) * weights[3];
			}
			else
			{
				sumCol += texture(textureMap,vuv+vec2(step,0.0f)) * weights[3+i];
				sumCol += texture(textureMap,vuv-vec2(step,0.0f)) * weights[3-i];
			}
		}
		sumCol[3] = 1.0f;
		outColor = sumCol;
	}
	else
	{
		vec4 sumCol = vec4(0.0f,0.0f,0.0f,1.0f);
		for(int i=0; i<3; ++i)
		{
			if(i==0)
			{
				sumCol += texture(textureMap,vuv) * weights[3];
			}
			else
			{
				sumCol += texture(textureMap,vuv+vec2(0.0f,step)) * weights[3+i];
				sumCol += texture(textureMap,vuv-vec2(0.0f,step)) * weights[3-i];
			}
		}
		sumCol[3] = 1.0f;
		outColor = sumCol;
	}
}