#version 400

layout(points, invocations=1) in;
layout(points, max_vertices=1) out;

uniform float elapsedTime;
uniform float maxHeight;

in vec4 vPosition[1];

out vec4 gPosition;

const float speed = 0.08f;

void main()
{
	vec4 newPos = vPosition[0];

	newPos.y += elapsedTime * speed;
	
	if(newPos.y > maxHeight)
	{
		newPos.y = -0.2f;
	}

	gPosition = newPos;
	gl_Position = gPosition;

	EmitVertex();
}