#version 400 core

layout(vertices = 3) out;
in vec3 vVertex[];
in vec2 vUV[];
out vec3 tcVertex[];
out vec2 tcUV[];

uniform vec3 viewPoint;
uniform bool doTesselation;
uniform float maxtessLevel;
uniform float tessAttenuation;

#define ID gl_InvocationID; //Funktioniert nicht

void main()
{
	tcVertex[gl_InvocationID] = vVertex[gl_InvocationID];
	tcUV[gl_InvocationID] = vUV[gl_InvocationID];
	if(gl_InvocationID == 0)
	{
		float tessLevel;
		if(doTesselation)
			tessLevel = min(max(maxtessLevel - length(viewPoint - vVertex[gl_InvocationID]) * tessAttenuation, 1.0f), maxtessLevel);
		else
			tessLevel = 1.0f;
		gl_TessLevelInner[0] = tessLevel;
		gl_TessLevelOuter[0] = tessLevel;
		gl_TessLevelOuter[1] = tessLevel;
		gl_TessLevelOuter[2] = tessLevel;
	}
}