#version 400 core

uniform mat4 modelMatrix;
uniform mat4 vpMatrix;
uniform mat3 normalMatrix;
uniform mat4 SMMatrix;

layout(triangles) in;
layout(triangle_strip, max_vertices = 3) out;
in vec3 tePosition[3];
in vec3 teNormal[3];
in vec2 teUV[3];
smooth out vec3 point;
out vec3 gNormal;
out vec2 gUV;
out vec4 gSMVertex;
	 
void main()
{
	for(int i=0; i<3; ++i)
	{
		gNormal = normalize(normalMatrix * teNormal[i]);
		gUV = teUV[i];
		
		vec4 vertexPos = gl_in[i].gl_Position;

		vertexPos = modelMatrix * vertexPos;
		point = (vertexPos).xyz;
		gl_Position = vpMatrix * vertexPos;
		gSMVertex = SMMatrix * vertexPos;
		EmitVertex();
	}
	
	EndPrimitive();
}