#version 400 core

layout(triangles, equal_spacing, cw) in;
in vec3 tcPosition[];
in vec3 tcNormal[];
in vec2 tcUV[];

out vec3 tePosition;
out vec3 teNormal;
out vec2 teUV;

void main()
{
	vec3 p0 = gl_TessCoord.x * tcPosition[0];
	vec3 p1 = gl_TessCoord.y * tcPosition[1];
	vec3 p2 = gl_TessCoord.z * tcPosition[2];
	tePosition = p0 + p1 + p2;
	vec3 n0 = gl_TessCoord.x * tcNormal[0];
	vec3 n1 = gl_TessCoord.y * tcNormal[1];
	vec3 n2 = gl_TessCoord.z * tcNormal[2];
	teNormal = normalize(n0 + n1 + n2);
	vec2 u0 = gl_TessCoord.x * tcUV[0];
	vec2 u1 = gl_TessCoord.y * tcUV[1];
	vec2 u2 = gl_TessCoord.z * tcUV[2];
	teUV = u0 + u1 + u2;
	gl_Position = vec4(tePosition, 1.0f);
}